# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['UserArgs', 'User']

@pulumi.input_type
class UserArgs:
    def __init__(__self__, *,
                 email: pulumi.Input[str],
                 username: pulumi.Input[str],
                 comment: Optional[pulumi.Input[str]] = None,
                 company: Optional[pulumi.Input[str]] = None,
                 custom_attributes: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 department: Optional[pulumi.Input[str]] = None,
                 directory_id: Optional[pulumi.Input[int]] = None,
                 distinguished_name: Optional[pulumi.Input[str]] = None,
                 external_id: Optional[pulumi.Input[int]] = None,
                 firstname: Optional[pulumi.Input[str]] = None,
                 group_id: Optional[pulumi.Input[int]] = None,
                 lastname: Optional[pulumi.Input[str]] = None,
                 manager_ad_id: Optional[pulumi.Input[int]] = None,
                 manager_user_id: Optional[pulumi.Input[int]] = None,
                 member_of: Optional[pulumi.Input[str]] = None,
                 phone: Optional[pulumi.Input[str]] = None,
                 samaccountname: Optional[pulumi.Input[str]] = None,
                 state: Optional[pulumi.Input[int]] = None,
                 status: Optional[pulumi.Input[int]] = None,
                 title: Optional[pulumi.Input[str]] = None,
                 trusted_idp_id: Optional[pulumi.Input[int]] = None,
                 userprincipalname: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a User resource.
        :param pulumi.Input[str] email: The user's email.
        :param pulumi.Input[str] username: The user's username.
        :param pulumi.Input[str] comment: A comment about the user
        :param pulumi.Input[str] company: The user's company
        :param pulumi.Input[str] department: The user's department
        :param pulumi.Input[int] directory_id: The user's directory_id
        :param pulumi.Input[str] distinguished_name: The user's distinguished name
        :param pulumi.Input[int] external_id: The user's external_id
        :param pulumi.Input[str] firstname: The user's first name
        :param pulumi.Input[int] group_id: The user's group_id
        :param pulumi.Input[str] lastname: The user's last name
        :param pulumi.Input[int] manager_ad_id: The user's manager_ad_id
        :param pulumi.Input[int] manager_user_id: The user's manager_user_id
        :param pulumi.Input[str] member_of: The user's member_of
        :param pulumi.Input[str] phone: The user's phone number
        :param pulumi.Input[str] samaccountname: The user's samaccount name
        :param pulumi.Input[int] state: The user's state. Must be one of `0: Unapproved` `1: Approved` `2: Rejected` `3: Unlicensed`
        :param pulumi.Input[int] status: The user's status. Must be one of `0: Unactivated` `1: Active` `2: Suspended` `3: Locked` `4: Password expired` `5: Awaiting password reset` `7: Password Pending` `8: Security questions required`
        :param pulumi.Input[str] title: The user's title
        :param pulumi.Input[int] trusted_idp_id: The user's trusted_idp_id
        :param pulumi.Input[str] userprincipalname: The user's user principal name
        """
        pulumi.set(__self__, "email", email)
        pulumi.set(__self__, "username", username)
        if comment is not None:
            pulumi.set(__self__, "comment", comment)
        if company is not None:
            pulumi.set(__self__, "company", company)
        if custom_attributes is not None:
            pulumi.set(__self__, "custom_attributes", custom_attributes)
        if department is not None:
            pulumi.set(__self__, "department", department)
        if directory_id is not None:
            pulumi.set(__self__, "directory_id", directory_id)
        if distinguished_name is not None:
            pulumi.set(__self__, "distinguished_name", distinguished_name)
        if external_id is not None:
            pulumi.set(__self__, "external_id", external_id)
        if firstname is not None:
            pulumi.set(__self__, "firstname", firstname)
        if group_id is not None:
            pulumi.set(__self__, "group_id", group_id)
        if lastname is not None:
            pulumi.set(__self__, "lastname", lastname)
        if manager_ad_id is not None:
            pulumi.set(__self__, "manager_ad_id", manager_ad_id)
        if manager_user_id is not None:
            pulumi.set(__self__, "manager_user_id", manager_user_id)
        if member_of is not None:
            pulumi.set(__self__, "member_of", member_of)
        if phone is not None:
            pulumi.set(__self__, "phone", phone)
        if samaccountname is not None:
            pulumi.set(__self__, "samaccountname", samaccountname)
        if state is not None:
            pulumi.set(__self__, "state", state)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if title is not None:
            pulumi.set(__self__, "title", title)
        if trusted_idp_id is not None:
            pulumi.set(__self__, "trusted_idp_id", trusted_idp_id)
        if userprincipalname is not None:
            pulumi.set(__self__, "userprincipalname", userprincipalname)

    @property
    @pulumi.getter
    def email(self) -> pulumi.Input[str]:
        """
        The user's email.
        """
        return pulumi.get(self, "email")

    @email.setter
    def email(self, value: pulumi.Input[str]):
        pulumi.set(self, "email", value)

    @property
    @pulumi.getter
    def username(self) -> pulumi.Input[str]:
        """
        The user's username.
        """
        return pulumi.get(self, "username")

    @username.setter
    def username(self, value: pulumi.Input[str]):
        pulumi.set(self, "username", value)

    @property
    @pulumi.getter
    def comment(self) -> Optional[pulumi.Input[str]]:
        """
        A comment about the user
        """
        return pulumi.get(self, "comment")

    @comment.setter
    def comment(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "comment", value)

    @property
    @pulumi.getter
    def company(self) -> Optional[pulumi.Input[str]]:
        """
        The user's company
        """
        return pulumi.get(self, "company")

    @company.setter
    def company(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "company", value)

    @property
    @pulumi.getter(name="customAttributes")
    def custom_attributes(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        return pulumi.get(self, "custom_attributes")

    @custom_attributes.setter
    def custom_attributes(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "custom_attributes", value)

    @property
    @pulumi.getter
    def department(self) -> Optional[pulumi.Input[str]]:
        """
        The user's department
        """
        return pulumi.get(self, "department")

    @department.setter
    def department(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "department", value)

    @property
    @pulumi.getter(name="directoryId")
    def directory_id(self) -> Optional[pulumi.Input[int]]:
        """
        The user's directory_id
        """
        return pulumi.get(self, "directory_id")

    @directory_id.setter
    def directory_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "directory_id", value)

    @property
    @pulumi.getter(name="distinguishedName")
    def distinguished_name(self) -> Optional[pulumi.Input[str]]:
        """
        The user's distinguished name
        """
        return pulumi.get(self, "distinguished_name")

    @distinguished_name.setter
    def distinguished_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "distinguished_name", value)

    @property
    @pulumi.getter(name="externalId")
    def external_id(self) -> Optional[pulumi.Input[int]]:
        """
        The user's external_id
        """
        return pulumi.get(self, "external_id")

    @external_id.setter
    def external_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "external_id", value)

    @property
    @pulumi.getter
    def firstname(self) -> Optional[pulumi.Input[str]]:
        """
        The user's first name
        """
        return pulumi.get(self, "firstname")

    @firstname.setter
    def firstname(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "firstname", value)

    @property
    @pulumi.getter(name="groupId")
    def group_id(self) -> Optional[pulumi.Input[int]]:
        """
        The user's group_id
        """
        return pulumi.get(self, "group_id")

    @group_id.setter
    def group_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "group_id", value)

    @property
    @pulumi.getter
    def lastname(self) -> Optional[pulumi.Input[str]]:
        """
        The user's last name
        """
        return pulumi.get(self, "lastname")

    @lastname.setter
    def lastname(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "lastname", value)

    @property
    @pulumi.getter(name="managerAdId")
    def manager_ad_id(self) -> Optional[pulumi.Input[int]]:
        """
        The user's manager_ad_id
        """
        return pulumi.get(self, "manager_ad_id")

    @manager_ad_id.setter
    def manager_ad_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "manager_ad_id", value)

    @property
    @pulumi.getter(name="managerUserId")
    def manager_user_id(self) -> Optional[pulumi.Input[int]]:
        """
        The user's manager_user_id
        """
        return pulumi.get(self, "manager_user_id")

    @manager_user_id.setter
    def manager_user_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "manager_user_id", value)

    @property
    @pulumi.getter(name="memberOf")
    def member_of(self) -> Optional[pulumi.Input[str]]:
        """
        The user's member_of
        """
        return pulumi.get(self, "member_of")

    @member_of.setter
    def member_of(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "member_of", value)

    @property
    @pulumi.getter
    def phone(self) -> Optional[pulumi.Input[str]]:
        """
        The user's phone number
        """
        return pulumi.get(self, "phone")

    @phone.setter
    def phone(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "phone", value)

    @property
    @pulumi.getter
    def samaccountname(self) -> Optional[pulumi.Input[str]]:
        """
        The user's samaccount name
        """
        return pulumi.get(self, "samaccountname")

    @samaccountname.setter
    def samaccountname(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "samaccountname", value)

    @property
    @pulumi.getter
    def state(self) -> Optional[pulumi.Input[int]]:
        """
        The user's state. Must be one of `0: Unapproved` `1: Approved` `2: Rejected` `3: Unlicensed`
        """
        return pulumi.get(self, "state")

    @state.setter
    def state(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "state", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[int]]:
        """
        The user's status. Must be one of `0: Unactivated` `1: Active` `2: Suspended` `3: Locked` `4: Password expired` `5: Awaiting password reset` `7: Password Pending` `8: Security questions required`
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter
    def title(self) -> Optional[pulumi.Input[str]]:
        """
        The user's title
        """
        return pulumi.get(self, "title")

    @title.setter
    def title(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "title", value)

    @property
    @pulumi.getter(name="trustedIdpId")
    def trusted_idp_id(self) -> Optional[pulumi.Input[int]]:
        """
        The user's trusted_idp_id
        """
        return pulumi.get(self, "trusted_idp_id")

    @trusted_idp_id.setter
    def trusted_idp_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "trusted_idp_id", value)

    @property
    @pulumi.getter
    def userprincipalname(self) -> Optional[pulumi.Input[str]]:
        """
        The user's user principal name
        """
        return pulumi.get(self, "userprincipalname")

    @userprincipalname.setter
    def userprincipalname(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "userprincipalname", value)


@pulumi.input_type
class _UserState:
    def __init__(__self__, *,
                 comment: Optional[pulumi.Input[str]] = None,
                 company: Optional[pulumi.Input[str]] = None,
                 custom_attributes: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 department: Optional[pulumi.Input[str]] = None,
                 directory_id: Optional[pulumi.Input[int]] = None,
                 distinguished_name: Optional[pulumi.Input[str]] = None,
                 email: Optional[pulumi.Input[str]] = None,
                 external_id: Optional[pulumi.Input[int]] = None,
                 firstname: Optional[pulumi.Input[str]] = None,
                 group_id: Optional[pulumi.Input[int]] = None,
                 lastname: Optional[pulumi.Input[str]] = None,
                 manager_ad_id: Optional[pulumi.Input[int]] = None,
                 manager_user_id: Optional[pulumi.Input[int]] = None,
                 member_of: Optional[pulumi.Input[str]] = None,
                 phone: Optional[pulumi.Input[str]] = None,
                 samaccountname: Optional[pulumi.Input[str]] = None,
                 state: Optional[pulumi.Input[int]] = None,
                 status: Optional[pulumi.Input[int]] = None,
                 title: Optional[pulumi.Input[str]] = None,
                 trusted_idp_id: Optional[pulumi.Input[int]] = None,
                 username: Optional[pulumi.Input[str]] = None,
                 userprincipalname: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering User resources.
        :param pulumi.Input[str] comment: A comment about the user
        :param pulumi.Input[str] company: The user's company
        :param pulumi.Input[str] department: The user's department
        :param pulumi.Input[int] directory_id: The user's directory_id
        :param pulumi.Input[str] distinguished_name: The user's distinguished name
        :param pulumi.Input[str] email: The user's email.
        :param pulumi.Input[int] external_id: The user's external_id
        :param pulumi.Input[str] firstname: The user's first name
        :param pulumi.Input[int] group_id: The user's group_id
        :param pulumi.Input[str] lastname: The user's last name
        :param pulumi.Input[int] manager_ad_id: The user's manager_ad_id
        :param pulumi.Input[int] manager_user_id: The user's manager_user_id
        :param pulumi.Input[str] member_of: The user's member_of
        :param pulumi.Input[str] phone: The user's phone number
        :param pulumi.Input[str] samaccountname: The user's samaccount name
        :param pulumi.Input[int] state: The user's state. Must be one of `0: Unapproved` `1: Approved` `2: Rejected` `3: Unlicensed`
        :param pulumi.Input[int] status: The user's status. Must be one of `0: Unactivated` `1: Active` `2: Suspended` `3: Locked` `4: Password expired` `5: Awaiting password reset` `7: Password Pending` `8: Security questions required`
        :param pulumi.Input[str] title: The user's title
        :param pulumi.Input[int] trusted_idp_id: The user's trusted_idp_id
        :param pulumi.Input[str] username: The user's username.
        :param pulumi.Input[str] userprincipalname: The user's user principal name
        """
        if comment is not None:
            pulumi.set(__self__, "comment", comment)
        if company is not None:
            pulumi.set(__self__, "company", company)
        if custom_attributes is not None:
            pulumi.set(__self__, "custom_attributes", custom_attributes)
        if department is not None:
            pulumi.set(__self__, "department", department)
        if directory_id is not None:
            pulumi.set(__self__, "directory_id", directory_id)
        if distinguished_name is not None:
            pulumi.set(__self__, "distinguished_name", distinguished_name)
        if email is not None:
            pulumi.set(__self__, "email", email)
        if external_id is not None:
            pulumi.set(__self__, "external_id", external_id)
        if firstname is not None:
            pulumi.set(__self__, "firstname", firstname)
        if group_id is not None:
            pulumi.set(__self__, "group_id", group_id)
        if lastname is not None:
            pulumi.set(__self__, "lastname", lastname)
        if manager_ad_id is not None:
            pulumi.set(__self__, "manager_ad_id", manager_ad_id)
        if manager_user_id is not None:
            pulumi.set(__self__, "manager_user_id", manager_user_id)
        if member_of is not None:
            pulumi.set(__self__, "member_of", member_of)
        if phone is not None:
            pulumi.set(__self__, "phone", phone)
        if samaccountname is not None:
            pulumi.set(__self__, "samaccountname", samaccountname)
        if state is not None:
            pulumi.set(__self__, "state", state)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if title is not None:
            pulumi.set(__self__, "title", title)
        if trusted_idp_id is not None:
            pulumi.set(__self__, "trusted_idp_id", trusted_idp_id)
        if username is not None:
            pulumi.set(__self__, "username", username)
        if userprincipalname is not None:
            pulumi.set(__self__, "userprincipalname", userprincipalname)

    @property
    @pulumi.getter
    def comment(self) -> Optional[pulumi.Input[str]]:
        """
        A comment about the user
        """
        return pulumi.get(self, "comment")

    @comment.setter
    def comment(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "comment", value)

    @property
    @pulumi.getter
    def company(self) -> Optional[pulumi.Input[str]]:
        """
        The user's company
        """
        return pulumi.get(self, "company")

    @company.setter
    def company(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "company", value)

    @property
    @pulumi.getter(name="customAttributes")
    def custom_attributes(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        return pulumi.get(self, "custom_attributes")

    @custom_attributes.setter
    def custom_attributes(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "custom_attributes", value)

    @property
    @pulumi.getter
    def department(self) -> Optional[pulumi.Input[str]]:
        """
        The user's department
        """
        return pulumi.get(self, "department")

    @department.setter
    def department(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "department", value)

    @property
    @pulumi.getter(name="directoryId")
    def directory_id(self) -> Optional[pulumi.Input[int]]:
        """
        The user's directory_id
        """
        return pulumi.get(self, "directory_id")

    @directory_id.setter
    def directory_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "directory_id", value)

    @property
    @pulumi.getter(name="distinguishedName")
    def distinguished_name(self) -> Optional[pulumi.Input[str]]:
        """
        The user's distinguished name
        """
        return pulumi.get(self, "distinguished_name")

    @distinguished_name.setter
    def distinguished_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "distinguished_name", value)

    @property
    @pulumi.getter
    def email(self) -> Optional[pulumi.Input[str]]:
        """
        The user's email.
        """
        return pulumi.get(self, "email")

    @email.setter
    def email(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "email", value)

    @property
    @pulumi.getter(name="externalId")
    def external_id(self) -> Optional[pulumi.Input[int]]:
        """
        The user's external_id
        """
        return pulumi.get(self, "external_id")

    @external_id.setter
    def external_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "external_id", value)

    @property
    @pulumi.getter
    def firstname(self) -> Optional[pulumi.Input[str]]:
        """
        The user's first name
        """
        return pulumi.get(self, "firstname")

    @firstname.setter
    def firstname(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "firstname", value)

    @property
    @pulumi.getter(name="groupId")
    def group_id(self) -> Optional[pulumi.Input[int]]:
        """
        The user's group_id
        """
        return pulumi.get(self, "group_id")

    @group_id.setter
    def group_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "group_id", value)

    @property
    @pulumi.getter
    def lastname(self) -> Optional[pulumi.Input[str]]:
        """
        The user's last name
        """
        return pulumi.get(self, "lastname")

    @lastname.setter
    def lastname(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "lastname", value)

    @property
    @pulumi.getter(name="managerAdId")
    def manager_ad_id(self) -> Optional[pulumi.Input[int]]:
        """
        The user's manager_ad_id
        """
        return pulumi.get(self, "manager_ad_id")

    @manager_ad_id.setter
    def manager_ad_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "manager_ad_id", value)

    @property
    @pulumi.getter(name="managerUserId")
    def manager_user_id(self) -> Optional[pulumi.Input[int]]:
        """
        The user's manager_user_id
        """
        return pulumi.get(self, "manager_user_id")

    @manager_user_id.setter
    def manager_user_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "manager_user_id", value)

    @property
    @pulumi.getter(name="memberOf")
    def member_of(self) -> Optional[pulumi.Input[str]]:
        """
        The user's member_of
        """
        return pulumi.get(self, "member_of")

    @member_of.setter
    def member_of(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "member_of", value)

    @property
    @pulumi.getter
    def phone(self) -> Optional[pulumi.Input[str]]:
        """
        The user's phone number
        """
        return pulumi.get(self, "phone")

    @phone.setter
    def phone(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "phone", value)

    @property
    @pulumi.getter
    def samaccountname(self) -> Optional[pulumi.Input[str]]:
        """
        The user's samaccount name
        """
        return pulumi.get(self, "samaccountname")

    @samaccountname.setter
    def samaccountname(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "samaccountname", value)

    @property
    @pulumi.getter
    def state(self) -> Optional[pulumi.Input[int]]:
        """
        The user's state. Must be one of `0: Unapproved` `1: Approved` `2: Rejected` `3: Unlicensed`
        """
        return pulumi.get(self, "state")

    @state.setter
    def state(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "state", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[int]]:
        """
        The user's status. Must be one of `0: Unactivated` `1: Active` `2: Suspended` `3: Locked` `4: Password expired` `5: Awaiting password reset` `7: Password Pending` `8: Security questions required`
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter
    def title(self) -> Optional[pulumi.Input[str]]:
        """
        The user's title
        """
        return pulumi.get(self, "title")

    @title.setter
    def title(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "title", value)

    @property
    @pulumi.getter(name="trustedIdpId")
    def trusted_idp_id(self) -> Optional[pulumi.Input[int]]:
        """
        The user's trusted_idp_id
        """
        return pulumi.get(self, "trusted_idp_id")

    @trusted_idp_id.setter
    def trusted_idp_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "trusted_idp_id", value)

    @property
    @pulumi.getter
    def username(self) -> Optional[pulumi.Input[str]]:
        """
        The user's username.
        """
        return pulumi.get(self, "username")

    @username.setter
    def username(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "username", value)

    @property
    @pulumi.getter
    def userprincipalname(self) -> Optional[pulumi.Input[str]]:
        """
        The user's user principal name
        """
        return pulumi.get(self, "userprincipalname")

    @userprincipalname.setter
    def userprincipalname(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "userprincipalname", value)


class User(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 comment: Optional[pulumi.Input[str]] = None,
                 company: Optional[pulumi.Input[str]] = None,
                 custom_attributes: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 department: Optional[pulumi.Input[str]] = None,
                 directory_id: Optional[pulumi.Input[int]] = None,
                 distinguished_name: Optional[pulumi.Input[str]] = None,
                 email: Optional[pulumi.Input[str]] = None,
                 external_id: Optional[pulumi.Input[int]] = None,
                 firstname: Optional[pulumi.Input[str]] = None,
                 group_id: Optional[pulumi.Input[int]] = None,
                 lastname: Optional[pulumi.Input[str]] = None,
                 manager_ad_id: Optional[pulumi.Input[int]] = None,
                 manager_user_id: Optional[pulumi.Input[int]] = None,
                 member_of: Optional[pulumi.Input[str]] = None,
                 phone: Optional[pulumi.Input[str]] = None,
                 samaccountname: Optional[pulumi.Input[str]] = None,
                 state: Optional[pulumi.Input[int]] = None,
                 status: Optional[pulumi.Input[int]] = None,
                 title: Optional[pulumi.Input[str]] = None,
                 trusted_idp_id: Optional[pulumi.Input[int]] = None,
                 username: Optional[pulumi.Input[str]] = None,
                 userprincipalname: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Manage User resources.

        This resource allows you to create and configure Users.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_onelogin as onelogin

        example = onelogin.User("example",
            email="timmy.tester@test.com",
            username="timmy.tester")
        ```

        ## Import

        A User can be imported via the OneLogin User ID.

        ```sh
         $ pulumi import onelogin:index/user:User example 12345678
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] comment: A comment about the user
        :param pulumi.Input[str] company: The user's company
        :param pulumi.Input[str] department: The user's department
        :param pulumi.Input[int] directory_id: The user's directory_id
        :param pulumi.Input[str] distinguished_name: The user's distinguished name
        :param pulumi.Input[str] email: The user's email.
        :param pulumi.Input[int] external_id: The user's external_id
        :param pulumi.Input[str] firstname: The user's first name
        :param pulumi.Input[int] group_id: The user's group_id
        :param pulumi.Input[str] lastname: The user's last name
        :param pulumi.Input[int] manager_ad_id: The user's manager_ad_id
        :param pulumi.Input[int] manager_user_id: The user's manager_user_id
        :param pulumi.Input[str] member_of: The user's member_of
        :param pulumi.Input[str] phone: The user's phone number
        :param pulumi.Input[str] samaccountname: The user's samaccount name
        :param pulumi.Input[int] state: The user's state. Must be one of `0: Unapproved` `1: Approved` `2: Rejected` `3: Unlicensed`
        :param pulumi.Input[int] status: The user's status. Must be one of `0: Unactivated` `1: Active` `2: Suspended` `3: Locked` `4: Password expired` `5: Awaiting password reset` `7: Password Pending` `8: Security questions required`
        :param pulumi.Input[str] title: The user's title
        :param pulumi.Input[int] trusted_idp_id: The user's trusted_idp_id
        :param pulumi.Input[str] username: The user's username.
        :param pulumi.Input[str] userprincipalname: The user's user principal name
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: UserArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manage User resources.

        This resource allows you to create and configure Users.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_onelogin as onelogin

        example = onelogin.User("example",
            email="timmy.tester@test.com",
            username="timmy.tester")
        ```

        ## Import

        A User can be imported via the OneLogin User ID.

        ```sh
         $ pulumi import onelogin:index/user:User example 12345678
        ```

        :param str resource_name: The name of the resource.
        :param UserArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(UserArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 comment: Optional[pulumi.Input[str]] = None,
                 company: Optional[pulumi.Input[str]] = None,
                 custom_attributes: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 department: Optional[pulumi.Input[str]] = None,
                 directory_id: Optional[pulumi.Input[int]] = None,
                 distinguished_name: Optional[pulumi.Input[str]] = None,
                 email: Optional[pulumi.Input[str]] = None,
                 external_id: Optional[pulumi.Input[int]] = None,
                 firstname: Optional[pulumi.Input[str]] = None,
                 group_id: Optional[pulumi.Input[int]] = None,
                 lastname: Optional[pulumi.Input[str]] = None,
                 manager_ad_id: Optional[pulumi.Input[int]] = None,
                 manager_user_id: Optional[pulumi.Input[int]] = None,
                 member_of: Optional[pulumi.Input[str]] = None,
                 phone: Optional[pulumi.Input[str]] = None,
                 samaccountname: Optional[pulumi.Input[str]] = None,
                 state: Optional[pulumi.Input[int]] = None,
                 status: Optional[pulumi.Input[int]] = None,
                 title: Optional[pulumi.Input[str]] = None,
                 trusted_idp_id: Optional[pulumi.Input[int]] = None,
                 username: Optional[pulumi.Input[str]] = None,
                 userprincipalname: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = UserArgs.__new__(UserArgs)

            __props__.__dict__["comment"] = comment
            __props__.__dict__["company"] = company
            __props__.__dict__["custom_attributes"] = custom_attributes
            __props__.__dict__["department"] = department
            __props__.__dict__["directory_id"] = directory_id
            __props__.__dict__["distinguished_name"] = distinguished_name
            if email is None and not opts.urn:
                raise TypeError("Missing required property 'email'")
            __props__.__dict__["email"] = email
            __props__.__dict__["external_id"] = external_id
            __props__.__dict__["firstname"] = firstname
            __props__.__dict__["group_id"] = group_id
            __props__.__dict__["lastname"] = lastname
            __props__.__dict__["manager_ad_id"] = manager_ad_id
            __props__.__dict__["manager_user_id"] = manager_user_id
            __props__.__dict__["member_of"] = member_of
            __props__.__dict__["phone"] = phone
            __props__.__dict__["samaccountname"] = samaccountname
            __props__.__dict__["state"] = state
            __props__.__dict__["status"] = status
            __props__.__dict__["title"] = title
            __props__.__dict__["trusted_idp_id"] = trusted_idp_id
            if username is None and not opts.urn:
                raise TypeError("Missing required property 'username'")
            __props__.__dict__["username"] = username
            __props__.__dict__["userprincipalname"] = userprincipalname
        super(User, __self__).__init__(
            'onelogin:index/user:User',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            comment: Optional[pulumi.Input[str]] = None,
            company: Optional[pulumi.Input[str]] = None,
            custom_attributes: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            department: Optional[pulumi.Input[str]] = None,
            directory_id: Optional[pulumi.Input[int]] = None,
            distinguished_name: Optional[pulumi.Input[str]] = None,
            email: Optional[pulumi.Input[str]] = None,
            external_id: Optional[pulumi.Input[int]] = None,
            firstname: Optional[pulumi.Input[str]] = None,
            group_id: Optional[pulumi.Input[int]] = None,
            lastname: Optional[pulumi.Input[str]] = None,
            manager_ad_id: Optional[pulumi.Input[int]] = None,
            manager_user_id: Optional[pulumi.Input[int]] = None,
            member_of: Optional[pulumi.Input[str]] = None,
            phone: Optional[pulumi.Input[str]] = None,
            samaccountname: Optional[pulumi.Input[str]] = None,
            state: Optional[pulumi.Input[int]] = None,
            status: Optional[pulumi.Input[int]] = None,
            title: Optional[pulumi.Input[str]] = None,
            trusted_idp_id: Optional[pulumi.Input[int]] = None,
            username: Optional[pulumi.Input[str]] = None,
            userprincipalname: Optional[pulumi.Input[str]] = None) -> 'User':
        """
        Get an existing User resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] comment: A comment about the user
        :param pulumi.Input[str] company: The user's company
        :param pulumi.Input[str] department: The user's department
        :param pulumi.Input[int] directory_id: The user's directory_id
        :param pulumi.Input[str] distinguished_name: The user's distinguished name
        :param pulumi.Input[str] email: The user's email.
        :param pulumi.Input[int] external_id: The user's external_id
        :param pulumi.Input[str] firstname: The user's first name
        :param pulumi.Input[int] group_id: The user's group_id
        :param pulumi.Input[str] lastname: The user's last name
        :param pulumi.Input[int] manager_ad_id: The user's manager_ad_id
        :param pulumi.Input[int] manager_user_id: The user's manager_user_id
        :param pulumi.Input[str] member_of: The user's member_of
        :param pulumi.Input[str] phone: The user's phone number
        :param pulumi.Input[str] samaccountname: The user's samaccount name
        :param pulumi.Input[int] state: The user's state. Must be one of `0: Unapproved` `1: Approved` `2: Rejected` `3: Unlicensed`
        :param pulumi.Input[int] status: The user's status. Must be one of `0: Unactivated` `1: Active` `2: Suspended` `3: Locked` `4: Password expired` `5: Awaiting password reset` `7: Password Pending` `8: Security questions required`
        :param pulumi.Input[str] title: The user's title
        :param pulumi.Input[int] trusted_idp_id: The user's trusted_idp_id
        :param pulumi.Input[str] username: The user's username.
        :param pulumi.Input[str] userprincipalname: The user's user principal name
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _UserState.__new__(_UserState)

        __props__.__dict__["comment"] = comment
        __props__.__dict__["company"] = company
        __props__.__dict__["custom_attributes"] = custom_attributes
        __props__.__dict__["department"] = department
        __props__.__dict__["directory_id"] = directory_id
        __props__.__dict__["distinguished_name"] = distinguished_name
        __props__.__dict__["email"] = email
        __props__.__dict__["external_id"] = external_id
        __props__.__dict__["firstname"] = firstname
        __props__.__dict__["group_id"] = group_id
        __props__.__dict__["lastname"] = lastname
        __props__.__dict__["manager_ad_id"] = manager_ad_id
        __props__.__dict__["manager_user_id"] = manager_user_id
        __props__.__dict__["member_of"] = member_of
        __props__.__dict__["phone"] = phone
        __props__.__dict__["samaccountname"] = samaccountname
        __props__.__dict__["state"] = state
        __props__.__dict__["status"] = status
        __props__.__dict__["title"] = title
        __props__.__dict__["trusted_idp_id"] = trusted_idp_id
        __props__.__dict__["username"] = username
        __props__.__dict__["userprincipalname"] = userprincipalname
        return User(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def comment(self) -> pulumi.Output[Optional[str]]:
        """
        A comment about the user
        """
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def company(self) -> pulumi.Output[Optional[str]]:
        """
        The user's company
        """
        return pulumi.get(self, "company")

    @property
    @pulumi.getter(name="customAttributes")
    def custom_attributes(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        return pulumi.get(self, "custom_attributes")

    @property
    @pulumi.getter
    def department(self) -> pulumi.Output[Optional[str]]:
        """
        The user's department
        """
        return pulumi.get(self, "department")

    @property
    @pulumi.getter(name="directoryId")
    def directory_id(self) -> pulumi.Output[int]:
        """
        The user's directory_id
        """
        return pulumi.get(self, "directory_id")

    @property
    @pulumi.getter(name="distinguishedName")
    def distinguished_name(self) -> pulumi.Output[Optional[str]]:
        """
        The user's distinguished name
        """
        return pulumi.get(self, "distinguished_name")

    @property
    @pulumi.getter
    def email(self) -> pulumi.Output[str]:
        """
        The user's email.
        """
        return pulumi.get(self, "email")

    @property
    @pulumi.getter(name="externalId")
    def external_id(self) -> pulumi.Output[int]:
        """
        The user's external_id
        """
        return pulumi.get(self, "external_id")

    @property
    @pulumi.getter
    def firstname(self) -> pulumi.Output[Optional[str]]:
        """
        The user's first name
        """
        return pulumi.get(self, "firstname")

    @property
    @pulumi.getter(name="groupId")
    def group_id(self) -> pulumi.Output[int]:
        """
        The user's group_id
        """
        return pulumi.get(self, "group_id")

    @property
    @pulumi.getter
    def lastname(self) -> pulumi.Output[Optional[str]]:
        """
        The user's last name
        """
        return pulumi.get(self, "lastname")

    @property
    @pulumi.getter(name="managerAdId")
    def manager_ad_id(self) -> pulumi.Output[int]:
        """
        The user's manager_ad_id
        """
        return pulumi.get(self, "manager_ad_id")

    @property
    @pulumi.getter(name="managerUserId")
    def manager_user_id(self) -> pulumi.Output[int]:
        """
        The user's manager_user_id
        """
        return pulumi.get(self, "manager_user_id")

    @property
    @pulumi.getter(name="memberOf")
    def member_of(self) -> pulumi.Output[Optional[str]]:
        """
        The user's member_of
        """
        return pulumi.get(self, "member_of")

    @property
    @pulumi.getter
    def phone(self) -> pulumi.Output[Optional[str]]:
        """
        The user's phone number
        """
        return pulumi.get(self, "phone")

    @property
    @pulumi.getter
    def samaccountname(self) -> pulumi.Output[Optional[str]]:
        """
        The user's samaccount name
        """
        return pulumi.get(self, "samaccountname")

    @property
    @pulumi.getter
    def state(self) -> pulumi.Output[int]:
        """
        The user's state. Must be one of `0: Unapproved` `1: Approved` `2: Rejected` `3: Unlicensed`
        """
        return pulumi.get(self, "state")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[int]:
        """
        The user's status. Must be one of `0: Unactivated` `1: Active` `2: Suspended` `3: Locked` `4: Password expired` `5: Awaiting password reset` `7: Password Pending` `8: Security questions required`
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def title(self) -> pulumi.Output[Optional[str]]:
        """
        The user's title
        """
        return pulumi.get(self, "title")

    @property
    @pulumi.getter(name="trustedIdpId")
    def trusted_idp_id(self) -> pulumi.Output[int]:
        """
        The user's trusted_idp_id
        """
        return pulumi.get(self, "trusted_idp_id")

    @property
    @pulumi.getter
    def username(self) -> pulumi.Output[str]:
        """
        The user's username.
        """
        return pulumi.get(self, "username")

    @property
    @pulumi.getter
    def userprincipalname(self) -> pulumi.Output[Optional[str]]:
        """
        The user's user principal name
        """
        return pulumi.get(self, "userprincipalname")

